
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

//THIS PROJECT DEVELOPED BY CORNELL ECE 3400 STAFF. PLEASE
//DO NOT REUSE OR DISTRIBUTE THIS CODE WITHOUT PERMISSION
//SPRING 2015

module VGAlogic(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// KEY //////////
	KEY,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO,
	GPIO_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO;
input 		     [1:0]		GPIO_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================
reg CLOCK_25;
wire [9:0] PIXEL_COORD_X;
wire [9:0] PIXEL_COORD_Y;
wire [7:0] PIXEL_COLOR;

wire reset;
wire [9:0] concat_location;
reg [1:0] pixel_in;
reg [9:0] pixel_index;
wire [1:0] pixel_out;
reg pixel_wen;

reg [9:0] counter; //for loop is too long to synthesize
reg counter_go; //counter enable

VGADriver driver(
	.CLOCK(CLOCK_25),
	.PIXEL_COLOR_IN(PIXEL_COLOR),
	.PIXEL_X(PIXEL_COORD_X),
	.PIXEL_Y(PIXEL_COORD_Y),
	.PIXEL_COLOR_OUT({GPIO[22],GPIO[20],GPIO[18],GPIO[16],GPIO[14],GPIO[12],GPIO[10],GPIO[8]}),
	.H_SYNC_NEG(GPIO[5]),
	.V_SYNC_NEG(GPIO[7])
);

blockArray pixelArray(
	.CLOCK(CLOCK_50),
	.INDEX(pixel_index),
	.IN(pixel_in),
	.W_EN(pixel_wen),
	.OUT(pixel_out)
);

assign concat_location[9:5] = PIXEL_COORD_X[9:5]; //shift by 5 for pixel->block transform
assign concat_location[4:0] = PIXEL_COORD_Y[9:5];

//=======================================================
//  Structural coding
//=======================================================
always @(posedge CLOCK_50) begin
	CLOCK_25 <= ~CLOCK_25; //VGA needs 25 MHz clock - FPGA has 50 MHz clock
	if (reset) begin
		counter <= 0; //iterate through all memory locations
		counter_go <= 1;
	end
	else if (counter_go) begin
		pixel_wen <= 1; //write 
		pixel_index <= counter; //location
		pixel_in <= 2'b00 + (counter[5] ^ counter[0]); //value
		if (counter == 10'b11_1111_1111) begin
			counter_go <= 0; //end of loop
		end
		counter <= counter + 10'd1;
	end
	else begin
		pixel_index <= concat_location;
		pixel_wen <= 0;
	end
end

assign reset = ~KEY[0];

//translate 2 bit pixel array values to 8 bit RGB
assign PIXEL_COLOR = (pixel_out == 2'b00 ? 8'b000_111_11 : 8'b000_000_11); 

endmodule
